<template>
    <v-container>
        <v-card elevation="2">
            <v-simple-table>
                <template v-slot:default>
                    <thead>
                        <tr>
                            <th class="text-left">Title</th>
                            <th class="text-left">Description</th>
                            <th class="text-left">Compelete</th>
                            <th class="text-center">Action</th>
                        </tr>
                    </thead>
                    <tbody class="boody">
                        <tr v-for="(item, index) in titles" :key="item">
                            <td class="title" v-if="show">
                                {{ item }}
                            </td>
                            <td v-else>
                                {{ item | short }}
                            </td>
                            <td class="descriptions" v-if="show">
                                {{ descriptions[index]  }}
                            </td>
                            <td v-else>
                                {{ descriptions[index] | short }}
                            </td>
                            <td>
                                <v-switch
                                    class="mx-9 d-flex"
                                    @click="toggleTheme"
                                >
                                </v-switch>
                            </td>
                            <td>
                                <v-row align="center" justify="space-around">
                                    <v-dialog
                                        v-model="dialog"
                                        persistent
                                        max-width="600px"
                                    >
                                        <template
                                            v-slot:activator="{ on, attrs }"
                                        >
                                            <v-btn
                                                class="mb-2"
                                                fab
                                                dark
                                                small
                                                color="cyan"
                                                v-bind="attrs"
                                                v-on="on"
                                                @click="changee(index)"
                                            >
                                                <v-icon dark>
                                                    mdi-pencil
                                                </v-icon>
                                            </v-btn>
                                        </template>
                                        <v-card>
                                            <v-card-title>
                                                <span class="text-h5"
                                                    >Edit Note</span
                                                >
                                            </v-card-title>
                                            <v-card-text>
                                                <v-container>
                                                    <v-row>
                                                        <v-col>
                                                            <v-text-field
                                                                v-model="
                                                                    dilogTitletitle
                                                                "
                                                                label="Note Title"
                                                            ></v-text-field>
                                                        </v-col>
                                                    </v-row>
                                                    <v-row>
                                                        <v-col>
                                                            <v-textarea
                                                                v-model="
                                                                    dilogDescription
                                                                "
                                                                label="Description"
                                                                required
                                                            ></v-textarea>
                                                        </v-col>
                                                    </v-row>
                                                </v-container>
                                            </v-card-text>
                                            <v-card-actions>
                                                <v-spacer></v-spacer>
                                                <v-btn
                                                    color="blue darken-1"
                                                    text
                                                    @click="dialog = false"
                                                >
                                                    Close
                                                </v-btn>
                                                <v-btn
                                                    color="blue darken-1"
                                                    text
                                                    @click="edit(index)"
                                                >
                                                    Save
                                                </v-btn>
                                            </v-card-actions>
                                        </v-card>
                                    </v-dialog>

                                    <v-btn color="primary" @click="read(index)">
                                        Read
                                    </v-btn>

                                    <v-dialog v-model="dialog3" width="500">
                                        <v-card>
                                            <v-card-title
                                                class="text-h5 grey lighten-2"
                                            >
                                                {{ textDialog }}
                                            </v-card-title>

                                            <v-card-text
                                                >{{ descriptionDialog }}
                                            </v-card-text>

                                            <v-divider></v-divider>

                                            <v-card-actions>
                                                <v-spacer></v-spacer>
                                                <v-btn
                                                    color="primary"
                                                    text
                                                    @click="closeRead "
                                                >
                                                    Close
                                                </v-btn>
                                            </v-card-actions>
                                        </v-card>
                                    </v-dialog>

                                    <v-btn
                                        class="ma-1 error"
                                        plain
                                        @click="dialog2 = true"
                                    >
                                        Delete
                                    </v-btn>

                                    <v-dialog
                                        v-model="dialog2"
                                        persistent
                                        max-width="290"
                                    >
                                        <v-card>
                                            <v-card-title class="text-h6">
                                                Are you sure you want to delete
                                                this note?
                                            </v-card-title>

                                            <v-card-actions>
                                                <v-spacer></v-spacer>
                                                <v-btn
                                                    color="red darken-1"
                                                    text
                                                    @click="dialog2 = false"
                                                >
                                                    Cancel
                                                </v-btn>
                                                <v-btn
                                                    class="ms-auto"
                                                    color="green darken-1"
                                                    text
                                                    @click="deleteNote(index)"
                                                    >Yes , delete it</v-btn
                                                >
                                            </v-card-actions>
                                        </v-card>
                                    </v-dialog>
                                </v-row>
                            </td>
                        </tr>
                    </tbody>
                </template>
            </v-simple-table>

            <AddDilog></AddDilog>
        </v-card>
    </v-container>
</template>
<script>
    import { mapGetters, mapActions } from 'vuex';

    import AddDilog from '../components/AddDilog.vue';

    export default {
        name: 'CurdNotes',
        data: () => ({
            dialog: false,
            dialog2: false,
            dialog3: false,
            show: false,
            dilogTitletitle: '',
            dilogDescription: '',
            textDialog: '',
            descriptionDialog: '',
            titles: '',
            descriptions: '',
        
        }),

        components: {
            AddDilog,
        },
        computed: {
            ...mapGetters({
                title: 'getTitle',
                description: 'getDescription',
                addDilog: 'getAddDilog',
            }),
            r: function () {
      return localStorage.titles
    }

        },
        methods: {
            ...mapActions({
                editDescriptione: 'editDescriptione',
                saveTitle: 'saveTitle',
                saveDescriptione: 'saveDescriptione',
            }),
            edit(i) {
                if (this.dilogDescription !== '') {
                    this.$store.commit('editDescriptione', i);
                    console.log(document.querySelector('.title'));
                    this.$store.commit('saveTitle', this.dilogTitletitle);
                    this.$store.commit(
                        'saveDescriptione',
                        this.dilogDescription
                    );
                    this.dialog = false;
                } else {
                    console.log('not change');
                    this.dialog = false;
                }
                location.reload()
               
            },
            changee(i) {
                this.dilogTitletitle = this.titles[i];
                this.dilogDescription = this.descriptions[i];
            },
            deleteNote(i) {

                console.log(i);

                this.$store.commit('editDescriptione', i);
                
                this.dialog2 = false;
                location.reload()
               
            },
            read(i) {
                this.dialog3 = true;
                this.show = true;
                this.textDialog = this.titles[i];
                this.descriptionDialog = this.descriptions[i];

                console.log('read');
            },
            closeRead(){
                this.dialog3=false
                this.show=false
            }
        },
        beforeMount() {
            
            if (localStorage.titles) {
                console.log(localStorage.titles.split(','));
                this.titles = localStorage.titles.split(',');
                console.log(this.titles);
                console.log(localStorage.descriptions.split(','));
                this.descriptions = localStorage.descriptions.split(',');
                console.log(this.descriptions);
                console.log("m");
            }
        },
   
    };
</script>

<style lang="scss" scoped>
.descriptions{
    max-width: 200px;
}
.title{
    max-width: 200px;
}

</style>

